package jumbo.xml.gui;

/* hacked from SplitPanePanel.java from SUN examples*/

import com.sun.java.swing.JButton;
import com.sun.java.swing.JComponent;
import com.sun.java.swing.JFrame;
import com.sun.java.swing.JLabel;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.JSplitPane;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/** a Split pane, simplified from the Swing example. Either vertical
or horizontal is allowed. All contained objects are JComponents
The resizing isn't perfect...
@author P.Murray-Rust, 1998
*/
public class XSplitPanePanel extends JPanel {
/** the split pane in the panel */
    protected JSplitPane         splitPane;
/** the first user-provided component */
	protected SplitComponent firstComponent;
/** the second user-provided component */
	protected SplitComponent secondComponent;

/** add two JComponents. If direction is JSplitPane.HORIZONTAL_SPLIT, then
first is the left component, second the right. If direction is 
JSplitPane.VERTICAL_SPLIT, then first is the top component, second 
the bottom. 
@param int direction (see above); 
@param first JComponent (see above); 
@param second JComponent (see above); 
*/
    public XSplitPanePanel(int direction, JComponent first, JComponent second) {
		super();
		if (first == null || second == null) {
			System.out.println("Null argument to XSplitPanePanel");
			return;
		}
		firstComponent = new SplitComponent(first);
		secondComponent = new SplitComponent(second);
		setDoubleBuffered(true);
		setLayout(new BorderLayout());
		firstComponent.setPreferredSize(100);
		secondComponent.setPreferredSize(100);
		splitPane = new JSplitPane(direction, firstComponent, secondComponent);
		splitPane.setContinuousLayout(false);
		splitPane.setPreferredSize(new Dimension(400, 100));
		add(splitPane, BorderLayout.CENTER);
    }

/** a simple test routine */
	public static void main(String[] args) {
		if (args.length == 0) {
			System.out.println("Usage: java XSplitPanePanel foo");
			System.exit(0);
		}
		XSplitPanePanel xsp1 = new XSplitPanePanel(JSplitPane.HORIZONTAL_SPLIT, new JButton("Left"), new JButton("Right"));
		XSplitPanePanel xsp2 = new XSplitPanePanel(JSplitPane.VERTICAL_SPLIT, new JButton("Top"), xsp1);
		JFrame jFrame = new JFrame("Text Split Panel");
		jFrame.getContentPane().add(xsp2);
		jFrame.setSize(300, 300);
		jFrame.pack();
		jFrame.show();
	}
}

class SplitComponent extends JComponent
{
    /** Preferred size. */
    protected int            preferredSize;

    public SplitComponent(JComponent comp) {
		this.setLayout(new BorderLayout());
		this.add(comp, BorderLayout.CENTER);
    }

    /**
     * Sets the preferred size to value.
     */
    public void setPreferredSize(int value) {
		preferredSize = value;
    }

    /**
     * Returns the preferred size, which is the value of setPreferredSize
     * as a Dimension.
     */
    public Dimension getPreferredSize() {
		return new Dimension(preferredSize, preferredSize);
    }

    /**
     * Returns the minimum size. JSplitPane keys of the minimum size to
     * determine where the divider can drag to. If the minimum size of the
     * two components being split are greater than the current size of the
     * splitpane, the splitpane will not allow you to drag the divider 
     * around.
     */
    public Dimension getMinimumSize() {
		return getPreferredSize();
    }

}
